{------------------------------------------------------------------------------}
{                              }
{           AES,                   }
{          Guardant                                                      }
{------------------------------------------------------------------------------}

program GenerateTownAES;

{$APPTYPE CONSOLE}

  uses
    SysUtils, Dialogs,
    GRDDelphi;
    
{----------------------------------------------------------------------------------------------}
{     Guardant API                                                       }

{ :    Guardant                                                             }
{	:                                                                              }
{--------------------------------------------------------------------------------------------- }
procedure ErrorHandling(hGrd:HANDLE;nRet:integer);
var
 ErrorMsg: Array[1..5000] of Char;
 PErrorMsg: PChar;
begin
  	  if( nRet <> GrdE_OK ) Then //   
	      begin
            //      Guardant     (      )
           GrdFormatMessage(hGrd,nRet,GrdLng_ENG,@ErrorMsg[1],5000,nil );
           PErrorMsg := @ErrorMsg;
           WriteLn(String(PErrorMsg));

           	if( hGrd <> nil )	Then //   ,      Guardant API
            begin
              //     
              GrdLogout(hGrd, 0);
              //  ,  
              GrdCloseHandle( hGrd );
            end;
            //   Guardant API
            GrdCleanup();
            writeln('Press Enter to exit');
            readln;
            halt(0);
	      end;
end;

//   
function PADR(Src: string; Lg: Integer): string;
begin
  Result := Src;
  while Length(Result) < Lg do
    Result := Result + ' ';
end;

  {  }
  const CryptPU:      DWORD=$8566783;							  {       }
        CryptRD:      DWORD=$17d49c84;							{       }
        CryptWR:      DWORD=$9843de24;							{       }
        CryptMS:      DWORD=$47832845;							{       }

{  }
  var 	dwPublic:     DWORD;				{    }
       	dwPrivRD:     DWORD;				{    }
//       	dwPrivWR:     DWORD;				{    }
//      	dwPrivMS:     DWORD;				{    }

        dwRemoteMode:         DWORD;					      {    }
        dwFlags:              DWORD;							  {   }
        byProg:               Byte;								  {   }
        byVer:                Byte;									{  }
        dwID:                 DWORD;								{   (ID) }
        wSN:                  Word;									{   }
        wMask:                Word;						      {   }
        wType:                Word;						      {   }
        dwModel:              DWORD;				        {   }
        dwInterface:          DWORD;			          {    }
        nRet:                 integer;			        {   }
        i:                    integer;
        szInitVectorAES:      string;               {    AES }
        hGrd:HANDLE;                                {   Guardant }

        //      
        FilePhoneCode : TextFile;
        FileResult : TextFile;
        TempStr : String;
        PosSeparate : Integer;
        StrCode, StrCity : String;     {     }

{------------------------- main block -----------------------------------------}
  begin

//  Guardant API
  nRet := GrdStartupEx(GrdFMR_Local, nil, nil);
  ErrorHandling(nil,nRet); {    }

//    Guardant API
  hGrd := GrdCreateHandle(nil, GrdCHM_MultiThread,  nil );
  ErrorHandling(hGrd,nRet);

  //      
  dwPublic:= GrdDC_DEMONVK-CryptPU;				{      }
  dwPrivRD:= GrdDC_DEMORDO-CryptRD;				{      }

  //      (   )
  nRet:= GrdSetAccessCodes(hGrd,   dwPublic + CryptPU,  dwPrivRD + CryptRD, 0, 0 );
  ErrorHandling(hGrd,nRet);

//    
    dwRemoteMode:= GrdFMR_Local;	{    }
    dwFlags:= GrdFM_nProg+GrdFM_Mask;     	    {       }
    dwID:=   0;                   {      }
    byProg:= 5; 	                {    ,      }
    wSN:=    0;	                  {       }
    byVer:=  0;                   {      }
    wMask:=  77;                  {    }
    dwModel:= GrdFMM_ALL;         {   }
    dwInterface:= GrdFMI_ALL;     {    }
    wType := 0;                   {      }
    nRet := GrdSetFindMode(hGrd,  dwRemoteMode, dwFlags, byProg, dwID, wSN, byVer, wMask, wType, dwModel, dwInterface );
    ErrorHandling(hGrd,nRet);

    //     (    GrdFindMode).
    //     Guardant API,    GrdCloseHandle()/GrdLogin()    
    nRet:= GrdLogin(hGrd,  $0FFFFFFFF, GrdLM_PerStation );
    ErrorHandling(hGrd,nRet);


	  {     }
    nRet := GrdPI_Activate(hGrd,				{   Guardant}
		                    05,					  {      }
		                    875679933 );	{       }
    ErrorHandling(hGrd,nRet);



	  {   }
	  writeln('Generates town table by AES algo: ');

    {      }
    AssignFile(FilePhoneCode, 'phonecode_rus.txt');
    Reset(FilePhoneCode);
    {  ,    }
    AssignFile(FileResult,'result_arr.txt');
    ReWrite(FileResult);


    ReadLn(FilePhoneCode,TempStr);  {      }
    while Not(EOF(FilePhoneCode)) Do
    Begin
       PosSeparate := pos(';', TempStr);
       StrCity := copy(TempStr,1,PosSeparate-1);
       StrCode := copy(TempStr,PosSeparate+1,Length(TempStr)-PosSeparate);

       {     AES    16,         }
       if (Length(StrCity)>32) then StrCity := PADR(StrCity,48);
       if (Length(StrCity)>16) then StrCity := PADR(StrCity,32);
       if (Length(StrCity)<16) then StrCity := PADR(StrCity,16);

  	  szInitVectorAES:= #10+#245+#177+#6+#33+#21+#5+#53+#88+#192+#18+#32+#44+#223+#55+#11; {    AES  }


      {       AES }

	    nRet:= GrdCrypt(hGrd,					  {   Guardant }
					          05,			            {    }
					          Length(StrCity),    {     }
                    @StrCity[1],			  {    }
                    GrdAM_CBC + GrdAM_Encrypt, 	        {    }
                    @szInitVectorAES[1],{   }
                    nil,                {       AES }
                    nil);			          {  . }
      ErrorHandling(hGrd,nRet);

      {         Delphi}
      TempStr := 'TelCodeArr.Add(Format('+#39+'%s=%s'+#39+',['+#39+StrCode+#39+',';
      for i := 1 To Length(StrCity)-1 Do
            TempStr := TempStr +'#' + IntToStr(ord(StrCity[i]))+ '+';

            TempStr := TempStr +'#' + IntToStr(ord(StrCity[Length(StrCity)]))+']));';
      writeln(FileResult, TempStr);
      ReadLn(FilePhoneCode,TempStr);
    end;

    { }
    CloseFile(FilePhoneCode);
    CloseFile(FileResult);


	  {    ,      }
    nRet := GrdPI_Deactivate(hGrd,				{   Guardant}
		                    05,					  {      }
		                    136056856 );	{       }
     ErrorHandling(nil,nRet);


	  {   hGrd }
    nRet:=GrdCloseHandle( hGrd );
    ErrorHandling(nil,nRet);

	  {   GrdAPI.  }
	  nRet:= GrdCleanup();
	  ErrorHandling(nil,nRet);

    writeln('All done. Press Enter to exit');
    readln;
end.
